#pragma once
#include "WMPacket.h"

/** This is a "proxy" packet, meant to stand in for areapacket-based packets. This is used for querying resolutions across the device network.
 (The network is not stateless and this info cannot simply be queried from the device itself -- a proxy build needs to be performed, filling in the correct sizes across the net).
*/
namespace WorldMachine {

class AreaProxyPacket : public WMAreaPacket {
public:
	AreaProxyPacket() {}

	static AreaPointer CreateNew(const PacketContext &context) {
		AreaPointer pkt = AREAPACKET(WorldMachine::core->memory->GetPacket(WMP_proxytype));
		pkt->Init(context);
		return pkt; 
	}

	virtual PacketPointer Clone() const
	{
		AreaPointer pkt = AREAPACKET(WorldMachine::core->memory->GetPacket(WMP_proxytype));
		*pkt = *this;
		return pkt;
	}

	bool proxyValid() { return true; };

	virtual void Clear()
	{
	}

	virtual int getType()
	{
		return WMP_proxytype;
	}

	virtual char * getTypeName()
	{
		return "Area Proxy";
	}

	virtual dword Color()
	{
		return 0x00;
	}

	virtual size_t getHeapUsage()
	{
		return 0;
	}

	virtual void resetContents()
	{
	}
};
}
