#pragma once
#include "common.h"
#include "ForwardDef.h"
#include "ContextOverride.h"

namespace WorldMachine {
	class DeviceGroup {
	public:
		enum FLAGS { NONE = 0, MOVECONTENTS = 1, FLOATING = 2 };
		DeviceGroup();
		void Load(std::istream &in);
		void Save(std::ostream &out);

		void setFloating(bool fl) { if (fl) flags |= FLOATING; else flags &= ~FLOATING; };
		bool isFloating() { return (flags & FLOATING) != 0; };
		bool isMoveCapable() { return true; };

		Rect4F area;
		WMString name;
		WMString desc;
		DWORD color;
		int alpha;
		int flags;		// group can be floated over other groups rather than pushes
		ContextOverride groupcontext;
	};
}