#pragma once
namespace WorldMachine {
	enum ADVANCED_INTERFACE_TYPE { INTERFACE_BASE, INTERFACE_CONTAINER };

	/** Base class for additional interfaces supported by a given device.

	Some devices need to expose additional functionality to the World Machine application. A good example of this is Macro
	devices, which need to allow the application to view their internal macroworlds.

	Device::QueryInterface(type) allows you to see if a given device exposes additional information and functionality to the outside world.

	For an example AdvancedDeviceInterface, see ContainerDeviceInterface.h

	@relates Device
	*/
	class AdvancedDeviceInterface {
	public:
		virtual ADVANCED_INTERFACE_TYPE getInterfaceEnum() = 0;
	};
};
